const fetch = require('node-fetch');
const open = require('open');
const token = process.argv[2];
const eventId = process.argv[3] || 'RXZlbnQ6NmVlNjM1MWUtZDUyMC00ZDJlLWFkNTAtODUyYTA0MzNkMjg5';

setInterval(async function() {
  const response = await fetch("https://api.ticketswap.com/graphql/public/batch?", {
    "credentials": "include",
    "headers": {
        "User-Agent": "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.15; rv:97.0) Gecko/20100101 Firefox/97.0",
        "Accept": "*/*",
        "Accept-Language": "fr-FR",
        "content-type": "application/json",
        "authorization": `Bearer ${token}`,
        "Sec-Fetch-Dest": "empty",
        "Sec-Fetch-Mode": "no-cors",
        "Sec-Fetch-Site": "cross-site",
        "Pragma": "no-cache",
        "Cache-Control": "no-cache"
    },
    "referrer": "https://www.ticketswap.fr/",
    "body": "[{\n  \"operationName\": \"getEventStructuredData\",\n  \"variables\": {\n    \"id\": \""+eventId+"\"\n  },\n  \"query\": \"query getEventStructuredData($id: ID!) {\\n  node(id: $id) {\\n    ... on Event {\\n      id\\n      name\\n      status\\n      uri {\\n        url\\n        __typename\\n      }\\n      lowestPrice {\\n        ...money\\n        __typename\\n      }\\n      artists {\\n        id\\n        name\\n        __typename\\n      }\\n      organizerBrands {\\n        id\\n        name\\n        __typename\\n      }\\n      startDate\\n      endDate\\n      availableTicketsCount\\n      location {\\n        id\\n        uri {\\n          url\\n          __typename\\n        }\\n        address\\n        zipcode\\n        name\\n        city {\\n          id\\n          name\\n          __typename\\n        }\\n        country {\\n          ...country\\n          __typename\\n        }\\n        __typename\\n      }\\n      types(first: 99) {\\n        edges {\\n          node {\\n            id\\n            availableListings: listings(first: 5, filter: {listingStatus: AVAILABLE}) {\\n              edges {\\n                node {\\n                  id\\n                  createdAt\\n                  price {\\n                    totalPriceWithTransactionFee {\\n                      ...money\\n                      __typename\\n                    }\\n                    __typename\\n                  }\\n                  uri {\\n                    url\\n                    __typename\\n                  }\\n                  __typename\\n                }\\n                __typename\\n              }\\n              __typename\\n            }\\n            __typename\\n          }\\n          __typename\\n        }\\n        __typename\\n      }\\n      __typename\\n    }\\n    __typename\\n  }\\n}\\n\\nfragment money on Money {\\n  amount\\n  currency\\n  __typename\\n}\\n\\nfragment country on Country {\\n  name\\n  code\\n  __typename\\n}\\n\"\n}]",
    "method": "POST",
    "mode": "cors"
});
  const data = await response.json();
  const available = !!data[0].data.node.availableTicketsCount;
  const url = data[0].data.node.uri.url;
  const date = new Date();
  let message = date.getHours()+'h'+('0'+date.getMinutes()).slice(-2)+':'+('0'+date.getSeconds()).slice(-2)+ ' ==> '
  message += available ? 'Tickets available!':'No tickets available';
  console.log(message);
  if(available) {
    open(url);
  }
}, 5000);

